// ****************************************************************************************
//
// Copyright (C) 2011 Jonathan Sandusky
// 
// This software is distributed under the terms of the Eclipse Public License v1.0.
// A copy of the license may be obtained at: http://www.eclipse.org/legal/epl-v10.html
//
// *************************************************************************************************

#include "CallbackManager.h"

#include "CallbackComponent.h"

#include <algorithm>

using namespace std;

CallbackManager* CallbackManager::m_instance = 0x0;

CallbackManager* CallbackManager::instance()
{
	if( m_instance == 0x0 )
		m_instance = new CallbackManager();
	return m_instance;
}

void CallbackManager::release()
{
	delete m_instance;
	m_instance = 0x0;
}

void CallbackManager::run()
{
}

void CallbackManager::addComponent(CallbackComponent* component)
{
	std::vector<CallbackComponent*>::iterator iter = find(m_CallbackComponents.begin(), m_CallbackComponents.end(), component);
	if (iter == m_CallbackComponents.end())
		m_CallbackComponents.push_back(component);
}

void CallbackManager::removeComponent(CallbackComponent* component)
{
	std::vector<CallbackComponent*>::iterator iter = find(m_CallbackComponents.begin(), m_CallbackComponents.end(), component);
	if (iter != m_CallbackComponents.end())
		m_CallbackComponents.erase(iter);		
}

void CallbackManager::setFactory(CallbackManager::FACTORY_FUNC aFunc) {
	factory_ = aFunc;
}

CALL CallbackManager::restoreCallback(const char* aFunc) {
	if (factory_ != 0x0)
		return (*factory_)(aFunc);
	return 0x0;
}