// ****************************************************************************************
//
// Copyright (C) 2011 Jonathan Sandusky
//
// This software is distributed under the terms of the Eclipse Public License v1.0.
// A copy of the license may be obtained at: http://www.eclipse.org/legal/epl-v10.html
//
// *************************************************************************************************

#ifndef CallbackManager_H_
#define CallbackManager_H_

#include <GameEngine/GameComponentManager.h>
#include <GameEngine\GameEvent.h>

#include <vector>

class CallbackComponent;


class CallbackManager : public GameComponentManager
{
public:
	typedef bool (*CALL)(bool, GameEvent&);
	typedef CALL (*FACTORY_FUNC)(const char*);

	static CallbackManager* instance();
	static void release();
	
	void run();

	void update() {}

	void addComponent(CallbackComponent* component);
	FACTORY_FUNC factory() {return factory_;}

	void removeComponent(CallbackComponent* component);
	void setFactory(FACTORY_FUNC aFunc);
	CALL restoreCallback(const char*);

private:
	static CallbackManager*	m_instance;
	FACTORY_FUNC factory_;
	CallbackManager() : factory_(0x0) {}
	~CallbackManager() {}

	std::vector<CallbackComponent*> m_CallbackComponents;
};
#endif