// ****************************************************************************************
//
// Copyright (C) 2011 Jonathan Sandusky
// 
// This software is distributed under the terms of the Eclipse Public License v1.0.
// A copy of the license may be obtained at: http://www.eclipse.org/legal/epl-v10.html
//
// *************************************************************************************************


#ifndef GAMEENGINE_SAPI_H_
#define GAMEENGINE_SAPI_H_

#include <GameEngine/config.h>

#ifdef PLATFORM_WIN
#	 ifdef CallbackComponent_EXPORTS
#       define CALLBACKAPI __declspec( dllexport )
#	 else
#       define CALLBACKAPI __declspec( dllimport )
#    endif
#else
#	 define CALLBACKAPI 
#endif

class GameEvent;

namespace GameEngine
{
	typedef bool (*CALLBACK_FUNC)(bool /*isCheckEvent*/, GameEvent&); //return value only tested for check event
	typedef CALLBACK_FUNC (*FACTORY_FUNC)(const char*); //To get a call back from a name
	
	CALLBACKAPI void registerCallback(unsigned int aEntityID, unsigned short aEventID, CALLBACK_FUNC aFunc, const char*);
	CALLBACKAPI bool removeCallback(unsigned int aEntityID, CALLBACK_FUNC aFunc);

	/**
	*	If you want to be able to predefine your functions via factory call this before scene load
	*/
	CALLBACKAPI void registerFactoryFunc(FACTORY_FUNC);
}

#endif