// ****************************************************************************************
//
// Copyright (C) 2011 Jonathan Sandusky
// 
// This software is distributed under the terms of the Eclipse Public License v1.0.
// A copy of the license may be obtained at: http://www.eclipse.org/legal/epl-v10.html
//
// *************************************************************************************************

#include <GameEngine/GameModules.h>
#include <GameEngine/GameComponentRegistry.h>

#include <iostream>

#include "CallbackManager.h"
#include "CallbackComponent.h"

struct lua_State;

#ifdef PLATFORM_WIN
#    define CALLBACKPLUGINEXP extern "C" __declspec( dllexport )
#else
#	 define COLLISIONPLUGINEXP 
#endif

CALLBACKPLUGINEXP void dllLoadGamePlugin(void)
{
	GameModules::componentRegistry()->registerComponent( "CallbackHandler", CallbackComponent::createComponent );	
	GameModules::componentRegistry()->registerManager( CallbackManager::instance() );	
}

CALLBACKPLUGINEXP void dllUnloadGamePlugin(void)
{
	GameModules::componentRegistry()->registerComponent( "CallbackHandler", 0);	
	GameModules::componentRegistry()->unregisterManager( CallbackManager::instance() );
	CallbackManager::release();
}

CALLBACKPLUGINEXP void dllRegisterLuaStack( lua_State* L )
{
	//???
}

